$INCLUDE "RAPIDQ.INC"
$APPTYPE   GUI
$TYPECHECK ON
$ESCAPECHARS ON

Function Dir_Of_Program As STRING
Dim BSpo AS INTEGER
BSpo = RINSTR(command$(0),"\\")
Dir_Of_Program = Delete$(command$(0),BSpo+1,len(command$(0))-BSpo)
End Function

' === CONST === '
CONST ProgDir$ = Dir_Of_Program
CONST InfoDir$ = ProgDir$
CONST	Global$ = "Global" '--  already
	CONST	Application$ = "Application"	:CONST	Clipboard$ = "Clipboard"
	CONST	Printer$ = "Printer"
CONST	Button$ = "Button" '--  Button
	CONST	QButton$ = "QButton"	:CONST	QCoolbtn$ = "QCoolbtn"
	CONST	QOvalbtn$ = "QOvalbtn"
CONST	Display$ = "Display" '--  display
	CONST	QForm$ = "QForm"	:CONST	QGauge$ = "QGauge"
	CONST	QGlassframe$ = "QGlassframe"	 :CONST	QLabel$ = "QLabel"
	CONST	QStatusbar$ = "QStatusbar"
CONST	File$ = "File" '--  File
	CONST	QFilelistbox$ = "QFilelistbox"	:CONST	QFilestream$ = "QFilestream"
	CONST	QMemorystream$ = "QMemorystream"	:CONST	QOpendialog$ = "QOpendialog"
	CONST	QSavedialog$ = "QSavedialog"
CONST	Font$ = "Font" '--  Font
	CONST	QFont$ = "QFont"	:CONST	QFontdialog$ = "QFontdialog"
CONST	Group$ = "Group" '--  Group
	CONST	QGroupbox$ = "QGroupbox"	:CONST	QHeader$ = "QHeader"
	CONST	QPanel$ = "QPanel"	:CONST	QScrollbox$ = "QScrollbox"
	CONST	QSplitter$ = "QSplitter"	:CONST	QTabcontrol$ = "QTabcontrol"
CONST	Inputt$ = "Input" '--  input
	CONST	QCheckbox$ = "QCheckbox"	:CONST	QCombobox$ = "QCombobox"
	CONST	QEdit$ = "QEdit"	 :CONST	QListbox$ = "QListbox"
	CONST	QRadiobutton$ = "QRadiobutton"	:CONST	QRichedit$ = "QRichedit"
	CONST	QStringgrid$ = "QStringgrid"	:CONST	QStringlist$ = "QStringlist"
CONST	Menu$ = "Menu" '--  menu
	CONST	QMainmenu$ = "QMainmenu"	:CONST	QMenuitem$ = "QMenuitem"
	CONST	QPopupmenu$ = "QPopupmenu"
CONST	Picture$ = "Picture" '--  picture
	CONST	QBitmap$ = "QBitmap"	:CONST	QIMage$ = "QIMage"
	CONST	QIMagelist$ = "QIMagelist"
CONST	Special$ = "Special" '-- special
	CONST	QCanvas$ = "QCanvas"	:CONST	QComport$ = "QComport"
	CONST	QMysql$ = "QMysql"	:CONST	QOlecontainer$ = "QOlecontainer"
	CONST	QOleobject$ = "QOleobject"	:CONST	QRegistry$ = "QRegistry"
	CONST	QScrollbar$ = "QScrollbar"	 :CONST	QSocket$ = "QSocket"
	CONST	QTimer$ = "QTimer"	:CONST	QTrackbar$ = "QTrackbar"
CONST	Tree$ = "Tree" '--  Tree
	CONST	QDirtree$ = "QDirtree"	:CONST	QListview$ = "QListview"
	CONST	QOutline$ = "QOutline"	:CONST	QTreeview$ = "QTreeview"

CONST CRLF$ = "\r\n"
CONST dbCRLF$ = CRLF$+CRLF$
CONST Dot = "."
CONST leftRADIO = 20
CONST SepGrid$ = "+"
CONST heightGrid=28 
CONST widthNum=40
DIM cou AS INTEGER
DIM curCol& AS INTEGER
DIM curRow& AS INTEGER

DIM popCopy AS QPopupMenu
	DIM icopCell AS QMenuItem
	DIM icopCol AS QMenuItem
	DIM icopRow AS QMenuItem
	DIM icopMethod AS QMenuItem

DIM Form AS QFORM
	DIM pnTop AS QPanel
		DIM pnRight AS QPanel
			DIM Tree AS QTREEVIEW
			DIM Split AS QSplitter
			DIM pnDsGrid AS QPanel
				DIM pnCurObject AS QPanel
					Dim CurObjectFont AS QFONT
				DIM GridPR AS QSTRINGGRID
				DIM GridME AS QSTRINGGRID
				DIM GridEV AS QSTRINGGRID
					DIM GridFont AS QFONT
	DIM pnBottom AS QPanel
		DIM grpTree AS QGroupBox
			DIM btnHide AS QButton
			DIM btnTreeChg AS QButton
			DIM btnTreeFE AS QButton
			DIM btnTreeCL AS QButton
		DIM grpGrid AS QGroupBox
		DIM grpINFO AS QGroupBox
			DIM rbtnPR AS QRadioButton
			DIM rbtnME AS QRadioButton
			DIM rbtnEV AS QRadioButton
			DIM rbtnIntType AS QRadioButton
		DIM boxPR as QRichEdit
		DIM boxME as QRichEdit
		DIM boxEV as QRichEdit
		DIM boxIN as QRichEdit

DIM s AS QSTRINGLIST
' - - - - - - - - - - - - - - - - - - - - EVENT - - - - - - - - - - - - - - - - - - - - '
SUB go2Grid( Sender AS QSTRINGGRID )
dim i as integer,n as integer
	Sender.RowCount = s.itemCount-1
	Sender.TopRow = 1
	for n=1 to s.itemCount-1
		Sender.Cell(0,n)= str$(n)
		for i=1 to 5
			Sender.Cell(i,n)=Field$(s.item(n),SepGrid$,i)
		next
	next
END SUB

function HaveIntType(index$ as string) as integer
	SELECT case index$
	case "QHeader","QListview","QStatusbar","QTreeview" : HaveIntType = True
	case else
		IF rbtnIntType.Checked=True THEN
			rbtnPR.Checked = True
		END IF
		HaveIntType = False
	END SELECT
end function

function NewMID$(big$,start$,end$) as string
'-- start$ position must be front of end$.
NewMid$= MID$(big$, instr(big$,start$), _
           instr(instr(big$,start$),big$,end$)-instr(big$,start$)+len(end$) _
           )
end function
	SUB LoadPR2Grid
		rbtnIntType.Enabled = HaveIntType(Tree.item(Tree.itemIndex).Text)
		SELECT case grpINFO.Tag
		case 1:	s.text = NewMID$(boxPR.Text,  dot+UCASE$(Tree.item(Tree.itemIndex).Text),  dbCRLF$)
				pnCurObject.Caption = Tree.item(Tree.itemIndex).Text+"  Properties"
				go2Grid( GridPR )
				GridPR.Visible=True
				GridME.Visible=False
				GridEV.Visible=False
		case 2:	s.text = NewMID$(boxME.Text,  dot+UCASE$(Tree.item(Tree.itemIndex).Text),  dbCRLF$)
				pnCurObject.Caption = Tree.item(Tree.itemIndex).Text+"  Methods"
				go2Grid( GridME )
				GridPR.Visible=False
				GridME.Visible=True
				GridEV.Visible=False
		case 3:	s.text = NewMID$(boxEV.Text,  dot+UCASE$(Tree.item(Tree.itemIndex).Text),  dbCRLF$)
				pnCurObject.Caption = Tree.item(Tree.itemIndex).Text+"  Events"
				go2Grid( GridEV )
				GridPR.Visible=False
				GridME.Visible=False
				GridEV.Visible=True
		case 4: 	s.text = NewMID$(boxIN.Text,  dot+UCASE$(Tree.item(Tree.itemIndex).Text),  dbCRLF$)
				pnCurObject.Caption = Tree.item(Tree.itemIndex).Text + "  Internal Types"
				go2Grid( GridPR )
				GridPR.Visible=True
				GridME.Visible=False
				GridEV.Visible=False
		end SELECT
	END SUB

SUB TreeSubStyle
	with Tree
		.Additems Global$,Button$,Display$,File$,Font$,Group$,Inputt$,Menu$,Picture$,Special$,Tree$
		.AddChildItems (0,Application$,Clipboard$,Printer$)	:cou=3
		.AddChildItems (1+cou,QButton$,QCoolbtn$,QOvalbtn$)	:cou=cou+3
		.AddChildItems (2+cou,QForm$,QGauge$,QGlassframe$,QLabel$,QStatusbar$)	:cou=cou+5
		.AddChildItems (3+cou,QFilelistbox$,QFilestream$,QMemorystream$,QOpendialog$,QSavedialog$)	:cou=cou+5
		.AddChildItems (4+cou,QFont$,QFontdialog$)	:cou=cou+2
		.AddChildItems (5+cou,QGroupbox$,QHeader$,QPanel$,QScrollbox$,QSplitter$,QTabcontrol$)	:cou=cou+6
		.AddChildItems (6+cou,QCheckbox$,QCombobox$,QEdit$,QListbox$,QRadiobutton$,QRichedit$,QStringgrid$,QStringlist$)	:cou=cou+8
		.AddChildItems (7+cou,QMainmenu$,QMenuitem$,QPopupmenu$)	:cou=cou+3
		.AddChildItems (8+cou,QBitmap$,QIMage$,QIMagelist$)	:cou=cou+3
		.AddChildItems (9+cou,QCanvas$,QComport$,QMysql$,QOlecontainer$,QOleobject$,QRegistry$,QScrollbar$,QSocket$,QTimer$,QTrackbar$)	 :cou=cou+10
		.AddChildItems (10+cou,QDirtree$,QListview$,QOutline$,QTreeview$)
	end with
END SUB

SUB TreeSortStyle
	Tree.Additems "object list"
	Tree.AddChildItems (0,Application$,Clipboard$,Printer$,QBitmap$,QButton$,QCanvas$,QCheckbox$,QCombobox$,QComport$,QCoolbtn$,QDirtree$,QEdit$,QFilelistbox$,QFilestream$,QFont$,QFontdialog$,QForm$,QGauge$,QGlassframe$,QGroupbox$,QHeader$,QIMage$,QIMagelist$,QLabel$,QListbox$,QListview$,QMainmenu$,QMemorystream$,QMenuitem$,QMysql$,QOlecontainer$,QOleobject$,QOpendialog$,QOutline$,QOvalbtn$,QPanel$,QPopupmenu$,QRadiobutton$,QRegistry$,QRichedit$,QSavedialog$,QScrollbar$,QScrollbox$,QSocket$,QSplitter$,QStatusbar$,QStringgrid$,QStringlist$,QTabcontrol$,QTimer$,QTrackbar$,QTreeview$)
END SUB

	SUB TreeClick
		IF Tree.item( Tree.itemIndex ).HasChildren=0 THEN
		LoadPR2Grid
		END IF
	END SUB

	SUB TreeNoEdit(Index%, AllowEdit%)
		AllowEdit%=False
	END SUB

	SUB btnHideClick
		select case btnHide.Caption[1]
		case "H"
		btnHide.Caption = "Show"
		Tree.Visible=False
		case "S"
		btnHide.Caption = "Hide"
		Tree.Visible=True
		end select		
	END SUB

	SUB btnTreeClClick
		Tree.FullCollapse
	END SUB

	SUB btnTreeFEClick
		Tree.FullExpand
	END SUB

SUB btnTreeChgClick
	IF Tree.Tag=1 THEN
	Tree.Clear
	TreeSubStyle
	Tree.Tag=2
	ELSEIF Tree.Tag=2 THEN
	Tree.Clear
	TreeSortStyle	
	Tree.Tag=1
	END IF
END SUB

SUB rbtnClick(Sender AS QRADIOBUTTON)
	grpINFO.Tag = Sender.Tag
	IF Tree.item( Tree.itemIndex ).HasChildren=0 THEN
	LoadPR2Grid
	END IF
END SUB

SUB icopCellCk
	SELECT case grpINFO.Tag
	case 1: ClipBoard.Text = GridPR.Cell( GridPR.Col, GridPR.Row )
	case 2: ClipBoard.Text = GridME.Cell( GridME.Col, GridME.Row )
	case 3: ClipBoard.Text = GridEV.Cell( GridEV.Col, GridEV.Row )
	case 1: ClipBoard.Text = GridPR.Cell( GridPR.Col, GridPR.Row )
	END SELECT
END SUB

Function GridCol$(Sender AS QStringGrid) As String
defstr gc$=""
	for cou=1 to Sender.RowCount-1
		gc$=gc$+Sender.Cell( Sender.Col, Cou )+"\r\n"
	next
GridCol$=gc$
End Function
	SUB icopColCk
		SELECT case grpINFO.Tag
		case 1: ClipBoard.Text = GridCol$(GridPR)
		case 2: ClipBoard.Text = GridCol$(GridME)
		case 3: ClipBoard.Text = GridCol$(GridEV)
		case 1: ClipBoard.Text = GridCol$(GridPR)
		END SELECT
	END SUB

Function GridRow$(Sender AS QStringGrid) As String
defstr gr$=""
	for cou=1 to Sender.ColCount-1
		gr$=gr$+Sender.Cell( Cou, Sender.Row )+"  "
	next
GridCol$=gr$
End Function
	SUB icopRowCk
		SELECT case grpINFO.Tag
		case 1: ClipBoard.Text = GridRow$(GridPR)
		case 2: ClipBoard.Text = GridRow$(GridME)
		case 3: ClipBoard.Text = GridRow$(GridEV)
		case 1: ClipBoard.Text = GridRow$(GridPR)
		END SELECT
	END SUB

function bracketComma$(s$ as string) as string
dim n as integer
dim bc$ as string
	n=tally( s$, "(")
	IF n=1 THEN
	n=tally( s$, ",")
			bc$="("
		IF n>0 THEN
				for cou=1 to n
				bc$=bc$+", "
				next
		END IF
			bc$=bc$+") '-- "+GridME.Cell(3,GridME.Row)
		bracketComma$=bc$
	ELSE
		bracketComma$=""
	END IF
end function
	SUB icopMethodCk '-- only for GridME
		ClipBoard.Text = GridME.Cell(1,GridME.Row)+bracketComma$( GridME.Cell(3,GridME.Row) )
	END SUB

SUB popCopyUp
	IF (Screen.MouseX > Form.Left+Tree.Width) AND (Screen.MouseX < Form.Left+Form.Width) AND _
	(Screen.MouseY > Form.Top+pnCurObject.Height) AND (Screen.MouseY < Form.Top+pnRight.Height) THEN
		icopCell.Enabled=True
		icopRow.Enabled=True
		icopCol.Enabled=True
		icopMethod.Enabled=(grpINFO.Tag=2)
	ELSE
		icopCell.Enabled=False
		icopRow.Enabled=False
		icopCol.Enabled=False
		icopMethod.Enabled=False
	END IF
END SUB

SUB FormShow
	Form.WindowState = 2
	boxPR.LoadFromFile( InfoDIR$+"000P.txt" )
	boxME.LoadFromFile( InfoDIR$+"000M.txt" )
	boxEV.LoadFromFile( InfoDIR$+"000E.txt" )
	boxIN.LoadFromFile( InfoDIR$+"000T.txt" )
	TreeSortStyle '	TreeSubStyle ( load TreeSortStyle first )
	Tree.itemIndex=1
	LoadPR2Grid
END SUB

' - - - - - - - - - - - - - - - - - - - - PROPERTY - - - - - - - - - - - - - - - - - - - - '
with popCopy
.Additems icopCell,icopCol,icopRow,icopMethod
.onPopup=popCopyUp
end with
with icopCell:.Caption = "Copy Cell":.OnClick = icopCellCk
end with
with icopCol:.Caption = "Copy Column":.OnClick = icopColCk
end with
with icopRow:.Caption = "Copy Row":.OnClick = icopRowCk
end with
with icopMethod:.Caption = "Copy Method":.OnClick = icopMethodCk
.Enabled=False
end with

with Form
.Width = 634:.Height = 500:.Center:.Caption = "Object Information version 1.2"
.PopupMenu = popCopy
.Visible= 1
.onShow =FormShow
end with
	with pnTop:.Parent = Form
	.Align = alClient
	end with
		with split:.Parent = pnTop:.Align = alLeft:.Width = 10:end with
		with Tree:.Parent = pnTop
		.Align = alLeft
		.Width = 166
		.OnClick = TreeClick
		.OnChange = TreeClick
		.OnEditing = TreeNoEdit
		.Tag =1
		end with
		with pnRight:.Parent = pnTop
		.Align = alClient
		.Bevelinner=0
		.BevelOuter=0
		end with
			with boxPR:.Parent = pnRight:.WordWrap =False:.Visible =False:end with
			with boxME:.Parent = pnRight:.WordWrap =False:.Visible =False:end with
			with boxEV:.Parent = pnRight:.WordWrap =False:.Visible =False:end with
			with boxIN:.Parent = pnRight:.WordWrap =False:.Visible =False:end with
			with pnDsGrid:.Parent = pnRight
			.Align = alClient
			end with
				with CurObjectFont:	.size=20	:.Name="Comic Sans MS":end with
				with pnCurObject:.Parent = pnDsGrid
				.Align = alTop	:.Height = 50
				.Caption = "Current Object"
				.Font = CurObjectFont
				end with
				with GridFont :.size=12 :.Name="Times New Roman" :.AddStyles(0):end with
				'-- PROPERTIES
				with GridPR:.Parent = pnDsGrid
				.Align = alClient	:.FixedCols = 1
				.Separator = SepGrid$	:.EditorMode =True	:.DelOptions(goHorzLine)
				.ColCount = 6	:.DefaultRowHeight= heightGrid
				.Cell(0,0)="No.":.Cell(1,0)=" Field"	:.Cell(2,0)=" Type"	:.Cell(3,0)=" Read/Write"	:.Cell(4,0)=" Default Value"	:.Cell(5,0)=" Support"
				.ColWidths(0)=widthNum:.ColWidths(1)=116	:.ColWidths(2)=150	:.ColWidths(3)=90		:.ColWidths(4)=102			:.ColWidths(5)=96
				.Font = GridFont
				end with
				with GridME:.Parent = pnDsGrid '-- GRID OF METHOD
				.Visible=False		:.Align = alClient
				.FixedCols = 1		:.Separator = SepGrid$
				.EditorMode =True	:.DelOptions(goHorzLine)
				.ColCount = 5		:.DefaultRowHeight= heightGrid
				.Cell(0,0)="No."	:.Cell(1,0)=" Method"	:.Cell(2,0)=" Type"	:.Cell(3,0)=" Params"	:.Cell(4,0)=" Support"
				.ColWidths(0)=widthNum	:.ColWidths(1)=116	:.ColWidths(2)=80	:.ColWidths(3)=264		:.ColWidths(4)=95
				.Font = GridFont
				end with
				with GridEV:.Parent = pnDsGrid '-- GRID OF EVENT
				.Visible=False		:.Align = alClient
				.FixedCols = 1		:.Separator = SepGrid$
				.EditorMode =True	:.DelOptions(goHorzLine)
				.ColCount = 5		:.DefaultRowHeight= heightGrid
				.Cell(0,0)="No."	:.Cell(1,0)=" Event"	:.Cell(2,0)=" Type"	:.Cell(3,0)=" Params"	:.Cell(4,0)=" Support"
				.ColWidths(0)=widthNum	:.ColWidths(1)=116	:.ColWidths(2)=80	:.ColWidths(3)=260		:.ColWidths(4)=99
				.Font = GridFont
				end with
		with pnBottom:.Parent = Form
		.Align = alBottom	:.Height = 160	:.BevelOuter = False
		end with
			with grpTree:.Parent = pnBottom
			.Align = alLeft	:.Caption = "Tree Command"
			end with
				with btnTreeChg:.Parent = grpTree
				.Align = alTop		:.Caption = "Change Style"
				.onClick = btnTreeChgClick
				end with
				with btnHide:.Parent = grpTree
				.Align = alTop		:.Caption = "Hide"
				.onClick = btnHideClick
				end with
				with btnTreeCL:.Parent = grpTree
				.Align = alTop		:.Caption = "Collapse"
				.onClick = btnTreeCLClick
				end with
				with btnTreeFE:.Parent = grpTree
				.Align = alTop		:.Caption = "Expand"
				.onClick = btnTreeFEClick
				end with
			with grpGrid:.Parent = pnBottom
			.Align = alClient
			.Caption = ""
			end with
			with grpINFO:.Parent = pnBottom
			.Align = alRight		:.Caption = "Information Selection"
			.Tag = 1
			end with
				with rbtnPR:.Parent = grpINFO
				.Top = 30	 :.Left = leftRADIO
				.Caption = "properties"
				.Checked = True	:.Tag = 1
				.onClick = rbtnClick
				end with
				with rbtnME:.Parent = grpINFO
				.Top = 60	 :.Left = leftRADIO
				.Caption = "method"	 :.Tag = 2
				.onClick = rbtnClick
				end with
				with rbtnEV:.Parent = grpINFO
				.Top = 90	:.Left = leftRADIO
				.Caption = "event"	:.Tag = 3
				.onClick = rbtnClick
				end with
				with rbtnIntType:.Parent = grpINFO
				.Top = 120 :.Left = leftRADIO
				.Caption = "Internal Type" :.Tag = 4
				.Enabled = False
				.onClick = rbtnClick
				end with
' - - - - - - - - - - - - - - - - - - - - DISPLAY - - - - - - - - - - - - - - - - - - - - '
Form.Visible= 0
Form.SHOWMODAL